This manual is for GNU GRUB (version 2.12, 3 May 2026).

   Copyright ©
1999,2000,2001,2002,2004,2006,2008,2009,2010,2011,2012,2013 Free
Software Foundation, Inc.

     Permission is granted to copy, distribute and/or modify this
     document under the terms of the GNU Free Documentation License,
     Version 1.2 or any later version published by the Free Software
     Foundation; with no Invariant Sections.

23.2 Firmware stalls instead of booting GRUB
============================================

The EFI implementation of some older MacBook laptops stalls when it gets
presented a grub-mkrescue ISO image for x86_64-efi target on an USB
stick.  Affected are models of year 2010 or earlier.  Workaround is to
zeroize the bytes 446 to 461 of the EFI partition, where mformat has put
a partition table entry which claims partition start at block 0.  This
change will not hamper bootability on other machines.

24 User-space utilities
***********************

24.1 Invoking grub-install
==========================

The program ‘grub-install’ generates a GRUB core image using
‘grub-mkimage’ and installs it on your system.  You must specify the
device name on which you want to install GRUB, like this:

     grub-install INSTALL_DEVICE

   The device name INSTALL_DEVICE is an OS device name or a GRUB device
name.

   ‘grub-install’ accepts the following options:

‘--help’
     Print a summary of the command-line options and exit.

‘--version’
     Print the version number of GRUB and exit.

‘--boot-directory=DIR’
     Install GRUB images under the directory ‘DIR/grub/’ This option is
     useful when you want to install GRUB into a separate partition or a
     removable disk.  If this option is not specified then it defaults
     to ‘/boot’, so

          grub-install /dev/sda

     is equivalent to

          grub-install --boot-directory=/boot/ /dev/sda

     Here is an example in which you have a separate “boot” partition
     which is mounted on ‘/mnt/boot’:

          grub-install --boot-directory=/mnt/boot /dev/sdb

‘--recheck’
     Recheck the device map, even if ‘/boot/grub/device.map’ already
     exists.  You should use this option whenever you add/remove a disk
     into/from your computer.

‘--no-rs-codes’
     By default on x86 BIOS systems, ‘grub-install’ will use some extra
     space in the bootloader embedding area for Reed-Solomon
     error-correcting codes.  This enables GRUB to still boot
     successfully if some blocks are corrupted.  The exact amount of
     protection offered is dependent on available space in the embedding
     area.  R sectors of redundancy can tolerate up to R/2 corrupted
     sectors.  This redundancy may be cumbersome if attempting to
     cryptographically validate the contents of the bootloader embedding
     area, or in more modern systems with GPT-style partition tables
     (see BIOS installation) where GRUB does not reside in any
     unpartitioned space outside of the MBR. Disable the Reed-Solomon
     codes with this option.

24.2 Invoking grub-mkconfig
===========================

The program ‘grub-mkconfig’ generates a configuration file for GRUB
(see Simple configuration).

     grub-mkconfig -o /boot/grub/grub.cfg

   ‘grub-mkconfig’ accepts the following options:

‘--help’
     Print a summary of the command-line options and exit.

‘--version’
     Print the version number of GRUB and exit.

‘-o FILE’
‘--output=FILE’
     Send the generated configuration file to FILE.  The default is to
     send it to standard output.

24.3 Invoking grub-mkpasswd-pbkdf2
==================================

The program ‘grub-mkpasswd-pbkdf2’ generates password hashes for GRUB
(see Security).

     grub-mkpasswd-pbkdf2

   ‘grub-mkpasswd-pbkdf2’ accepts the following options:

‘-c NUMBER’
‘--iteration-count=NUMBER’
     Number of iterations of the underlying pseudo-random function.
     Defaults to 10000.

‘-l NUMBER’
‘--buflen=NUMBER’
     Length of the generated hash.  Defaults to 64.

‘-s NUMBER’
‘--salt=NUMBER’
     Length of the salt.  Defaults to 64.

24.4 Invoking grub-mkrelpath
============================

The program ‘grub-mkrelpath’ makes a file system path relative to the
root of its containing file system.  For instance, if ‘/usr’ is a mount
point, then:

     $ grub-mkrelpath /usr/share/grub/unicode.pf2
     ‘/share/grub/unicode.pf2’

   This is mainly used internally by other GRUB utilities such as
‘grub-mkconfig’ (see Invoking grub-mkconfig), but may occasionally
also be useful for debugging.

   ‘grub-mkrelpath’ accepts the following options:

‘--help’
     Print a summary of the command-line options and exit.

‘--version’
     Print the version number of GRUB and exit.

24.5 Invoking grub-mkrescue
===========================

The program ‘grub-mkrescue’ generates a bootable GRUB rescue image
(see Making a GRUB bootable CD-ROM).

     grub-mkrescue -o grub.iso

   All arguments not explicitly listed as ‘grub-mkrescue’ options are
passed on directly to ‘xorriso’ in ‘mkisofs’ emulation mode.  Options
passed to ‘xorriso’ will normally be interpreted as ‘mkisofs’ options;
if the option ‘--’ is used, then anything after that will be interpreted
as native ‘xorriso’ options.

   Non-option arguments specify additional source directories.  This is
commonly used to add extra files to the image:

     mkdir -p disk/boot/grub
     (add extra files to ‘disk/boot/grub’)
     grub-mkrescue -o grub.iso disk

   ‘grub-mkrescue’ accepts the following options:

‘--help’
     Print a summary of the command-line options and exit.

‘--version’
     Print the version number of GRUB and exit.

‘-o FILE’
‘--output=FILE’
     Save output in FILE.  This "option" is required.

‘--modules=MODULES’
     Pre-load the named GRUB modules in the image.  Multiple entries in
     MODULES should be separated by whitespace (so you will probably
     need to quote this for your shell).

‘--rom-directory=DIR’
     If generating images for the QEMU or Coreboot platforms, copy the
     resulting ‘qemu.img’ or ‘coreboot.elf’ files respectively to the
     DIR directory as well as including them in the image.

‘--xorriso=FILE’
     Use FILE as the ‘xorriso’ program, rather than the built-in
     default.

‘--grub-mkimage=FILE’
     Use FILE as the ‘grub-mkimage’ program, rather than the built-in
     default.

24.6 Invoking grub-mount
========================

The program ‘grub-mount’ performs a read-only mount of any file system
or file system image that GRUB understands, using GRUB's file system
drivers via FUSE. (It is only available if FUSE development files were
present when GRUB was built.)  This has a number of uses:

   • It provides a convenient way to check how GRUB will view a file
     system at boot time.  You can use normal command-line tools to
     compare that view with that of your operating system, making it
     easy to find bugs.

   • It offers true read-only mounts.  Linux does not have these for
     journalling file systems, because it will always attempt to replay
     the journal at mount time; while you can temporarily mark the block
     device read-only to avoid this, that causes the mount to fail.
     Since GRUB intentionally contains no code for writing to file
     systems, it can easily provide a guaranteed read-only mount
     mechanism.

   • It allows you to examine any file system that GRUB understands
     without needing to load additional modules into your running
     kernel, which may be useful in constrained environments such as
     installers.

   • Since it can examine file system images (contained in regular
     files) just as easily as file systems on block devices, you can use
     it to inspect any file system image that GRUB understands with only
     enough privileges to use FUSE, even if nobody has yet written a
     FUSE module specifically for that file system type.

   Using ‘grub-mount’ is normally as simple as:

     grub-mount /dev/sda1 /mnt

   ‘grub-mount’ must be given one or more images and a mount point as
non-option arguments (if it is given more than one image, it will treat
them as a RAID set), and also accepts the following options:

‘--help’
     Print a summary of the command-line options and exit.

‘--version’
     Print the version number of GRUB and exit.

‘-C’
‘--crypto’
     Mount encrypted devices, prompting for a passphrase if necessary.

‘-d STRING’
‘--debug=STRING’
     Show debugging output for conditions matching STRING.

‘-K prompt|FILE’
‘--zfs-key=prompt|FILE’
     Load a ZFS encryption key.  If you use ‘prompt’ as the argument,
     ‘grub-mount’ will read a passphrase from the terminal; otherwise,
     it will read key material from the specified file.

‘-r DEVICE’
‘--root=DEVICE’
     Set the GRUB root device to DEVICE.  You do not normally need to
     set this; ‘grub-mount’ will automatically set the root device to
     the root of the supplied file system.

     If DEVICE is just a number, then it will be treated as a partition
     number within the supplied image.  This means that, if you have an
     image of an entire disk in ‘disk.img’, then you can use this
     command to mount its second partition:

          grub-mount -r 2 disk.img mount-point

‘-v’
‘--verbose’
     Print verbose messages.

24.7 Invoking grub-probe
========================

The program ‘grub-probe’ probes device information for a given path or
device.

     grub-probe --target=fs /boot/grub
     grub-probe --target=drive --device /dev/sda1

   ‘grub-probe’ must be given a path or device as a non-option argument,
and also accepts the following options:

‘--help’
     Print a summary of the command-line options and exit.

‘--version’
     Print the version number of GRUB and exit.

‘-d’
‘--device’
     If this option is given, then the non-option argument is a system
     device name (such as ‘/dev/sda1’), and ‘grub-probe’ will print
     information about that device.  If it is not given, then the
     non-option argument is a filesystem path (such as ‘/boot/grub’),
     and ‘grub-probe’ will print information about the device containing
     that part of the filesystem.

‘-m FILE’
‘--device-map=FILE’
     Use FILE as the device map (see Device map) rather than the
     default, usually ‘/boot/grub/device.map’.

‘-t TARGET’
‘--target=TARGET’
     Print information about the given path or device as defined by
     TARGET.  The available targets and their meanings are:

     ‘fs’
          GRUB filesystem module.
     ‘fs_uuid’
          Filesystem Universally Unique Identifier (UUID).
     ‘fs_label’
          Filesystem label.
     ‘drive’
          GRUB device name.
     ‘device’
          System device name.
     ‘partmap’
          GRUB partition map module.
     ‘abstraction’
          GRUB abstraction module (e.g.  ‘lvm’).
     ‘cryptodisk_uuid’
          Crypto device UUID.
     ‘msdos_parttype’
          MBR partition type code (two hexadecimal digits).
     ‘hints_string’
          A string of platform search hints suitable for passing to the
          ‘search’ command (see search).
     ‘bios_hints’
          Search hints for the PC BIOS platform.
     ‘ieee1275_hints’
          Search hints for the IEEE1275 platform.
     ‘baremetal_hints’
          Search hints for platforms where disks are addressed directly
          rather than via firmware.
     ‘efi_hints’
          Search hints for the EFI platform.
     ‘arc_hints’
          Search hints for the ARC platform.
     ‘compatibility_hint’
          A guess at a reasonable GRUB drive name for this device, which
          may be used as a fallback if the ‘search’ command fails.
     ‘disk’
          System device name for the whole disk.

‘-v’
‘--verbose’
     Print verbose messages.

24.8 Invoking grub-script-check
===============================

The program ‘grub-script-check’ takes a GRUB script file (see
Shell-like scripting) and checks it for syntax errors, similar to
commands such as ‘sh -n’.  It may take a PATH as a non-option argument;
if none is supplied, it will read from standard input.

     grub-script-check /boot/grub/grub.cfg

   ‘grub-script-check’ accepts the following options:

‘--help’
     Print a summary of the command-line options and exit.

‘--version’
     Print the version number of GRUB and exit.

‘-v’
‘--verbose’
     Print each line of input after reading it.

Appendix A How to obtain and build GRUB
***************************************

     *Caution:* GRUB requires binutils-2.9.1.0.23 or later because the
     GNU assembler has been changed so that it can produce real 16bits
     machine code between 2.9.1 and 2.9.1.0.x.  See
     <http://sources.redhat.com/binutils/>, to obtain information on how
     to get the latest version.

   GRUB is available from the GNU alpha archive site
<ftp://ftp.gnu.org/gnu/grub> or any of its mirrors.  The file will be
named grub-version.tar.gz.  The current version is 2.12, so the file you
should grab is:

   <ftp://ftp.gnu.org/gnu/grub/grub-2.12.tar.gz>

   To unbundle GRUB use the instruction:

     zcat grub-2.12.tar.gz | tar xvf -

   which will create a directory called ‘grub-2.12’ with all the
sources.  You can look at the file ‘INSTALL’ for detailed instructions
on how to build and install GRUB, but you should be able to just do:

     cd grub-2.12
     ./configure
     make install

   Also, the latest version is available using Git.  See
<http://www.gnu.org/software/grub/grub-download.html> for more
information.

Appendix B Reporting bugs
*************************

These are the guideline for how to report bugs.  Take a look at this
list below before you submit bugs:

  1. Before getting unsettled, read this manual through and through.
     Also, see the GNU GRUB FAQ
     (http://www.gnu.org/software/grub/grub-faq.html).

  2. Always mention the information on your GRUB. The version number and
     the configuration are quite important.  If you build it yourself,
     write the options specified to the configure script and your
     operating system, including the versions of gcc and binutils.

  3. If you have trouble with the installation, inform us of how you
     installed GRUB. Don't omit error messages, if any.  Just ‘GRUB
     hangs up when it boots’ is not enough.

     The information on your hardware is also essential.  These are
     especially important: the geometries and the partition tables of
     your hard disk drives and your BIOS.

  4. If GRUB cannot boot your operating system, write down _everything_
     you see on the screen.  Don't paraphrase them, like ‘The foo OS
     crashes with GRUB, even though it can boot with the bar boot loader
     just fine’.  Mention the commands you executed, the messages
     printed by them, and information on your operating system including
     the version number.

  5. Explain what you wanted to do.  It is very useful to know your
     purpose and your wish, and how GRUB didn't satisfy you.

  6. If you can investigate the problem yourself, please do.  That will
     give you and us much more information on the problem.  Attaching a
     patch is even better.

     When you attach a patch, make the patch in unified diff format, and
     write ChangeLog entries.  But, even when you make a patch, don't
     forget to explain the problem, so that we can understand what your
     patch is for.

  7. Write down anything that you think might be related.  Please
     understand that we often need to reproduce the same problem you
     encountered in our environment.  So your information should be
     sufficient for us to do the same thing--Don't forget that we cannot
     see your computer directly.  If you are not sure whether to state a
     fact or leave it out, state it!  Reporting too many things is much
     better than omitting something important.

   If you follow the guideline above, submit a report to the Bug
Tracking System (http://savannah.gnu.org/bugs/?group=grub).
Alternatively, you can submit a report via electronic mail to
<bug-grub@gnu.org>, but we strongly recommend that you use the Bug
Tracking System, because e-mail can be passed over easily.

   Once we get your report, we will try to fix the bugs.

Appendix C Where GRUB will go
*****************************

GRUB 2 is now quite stable and used in many production systems.  We are
currently working towards a 2.0 release.

   If you are interested in the development of GRUB 2, take a look at
the homepage (http://www.gnu.org/software/grub/grub.html).

Appendix D Copying This Manual
******************************

D.1 GNU Free Documentation License
==================================

                      Version 1.2, November 2002

     Copyright © 2000,2001,2002 Free Software Foundation, Inc.
     51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

  0. PREAMBLE

     The purpose of this License is to make a manual, textbook, or other
     functional and useful document “free” in the sense of freedom: to
     assure everyone the effective freedom to copy and redistribute it,
     with or without modifying it, either commercially or
     noncommercially.  Secondarily, this License preserves for the
     author and publisher a way to get credit for their work, while not
     being considered responsible for modifications made by others.

     This License is a kind of "copyleft", which means that derivative
     works of the document must themselves be free in the same sense.
     It complements the GNU General Public License, which is a copyleft
     license designed for free software.

     We have designed this License in order to use it for manuals for
     free software, because free software needs free documentation: a
     free program should come with manuals providing the same freedoms
     that the software does.  But this License is not limited to
     software manuals; it can be used for any textual work, regardless
     of subject matter or whether it is published as a printed book.  We
     recommend this License principally for works whose purpose is
     instruction or reference.

  1. APPLICABILITY AND DEFINITIONS

     This License applies to any manual or other work, in any medium,
     that contains a notice placed by the copyright holder saying it can
     be distributed under the terms of this License.  Such a notice
     grants a world-wide, royalty-free license, unlimited in duration,
     to use that work under the conditions stated herein.  The
     "Document", below, refers to any such manual or work.  Any member
     of the public is a licensee, and is addressed as "you".  You accept
     the license if you copy, modify or distribute the work in a way
     requiring permission under copyright law.

     A "Modified Version" of the Document means any work containing the
     Document or a portion of it, either copied verbatim, or with
     modifications and/or translated into another language.

     A "Secondary Section" is a named appendix or a front-matter section
     of the Document that deals exclusively with the relationship of the
     publishers or authors of the Document to the Document's overall
     subject (or to related matters) and contains nothing that could
     fall directly within that overall subject.  (Thus, if the Document
     is in part a textbook of mathematics, a Secondary Section may not
     explain any mathematics.)  The relationship could be a matter of
     historical connection with the subject or with related matters, or
     of legal, commercial, philosophical, ethical or political position
     regarding them.

     The "Invariant Sections" are certain Secondary Sections whose
     titles are designated, as being those of Invariant Sections, in the
     notice that says that the Document is released under this License.
     If a section does not fit the above definition of Secondary then it
     is not allowed to be designated as Invariant.  The Document may
     contain zero Invariant Sections.  If the Document does not identify
     any Invariant Sections then there are none.

     The "Cover Texts" are certain short passages of text that are
     listed, as Front-Cover Texts or Back-Cover Texts, in the notice
     that says that the Document is released under this License.  A
     Front-Cover Text may be at most 5 words, and a Back-Cover Text may
     be at most 25 words.

     A "Transparent" copy of the Document means a machine-readable copy,
     represented in a format whose specification is available to the
     general public, that is suitable for revising the document
     straightforwardly with generic text editors or (for images composed
     of pixels) generic paint programs or (for drawings) some widely
     available drawing editor, and that is suitable for input to text
     formatters or for automatic translation to a variety of formats
     suitable for input to text formatters.  A copy made in an otherwise
     Transparent file format whose markup, or absence of markup, has
     been arranged to thwart or discourage subsequent modification by
     readers is not Transparent.  An image format is not Transparent if
     used for any substantial amount of text.  A copy that is not
     "Transparent" is called "Opaque".

     Examples of suitable formats for Transparent copies include plain
     ASCII without markup, Texinfo input format, LaTeX input format,
     SGML or XML using a publicly available DTD, and standard-conforming
     simple HTML, PostScript or PDF designed for human modification.
     Examples of transparent image formats include PNG, XCF and JPG.
     Opaque formats include proprietary formats that can be read and
     edited only by proprietary word processors, SGML or XML for which
     the DTD and/or processing tools are not generally available, and
     the machine-generated HTML, PostScript or PDF produced by some word
     processors for output purposes only.

     The "Title Page" means, for a printed book, the title page itself,
     plus such following pages as are needed to hold, legibly, the
     material this License requires to appear in the title page.  For
     works in formats which do not have any title page as such, "Title
     Page" means the text near the most prominent appearance of the
     work's title, preceding the beginning of the body of the text.

     A section "Entitled XYZ" means a named subunit of the Document
     whose title either is precisely XYZ or contains XYZ in parentheses
     following text that translates XYZ in another language.  (Here XYZ
     stands for a specific section name mentioned below, such as
     "Acknowledgements", "Dedications", "Endorsements", or "History".)
     To "Preserve the Title" of such a section when you modify the
     Document means that it remains a section "Entitled XYZ" according
     to this definition.

     The Document may include Warranty Disclaimers next to the notice
     which states that this License applies to the Document.  These
     Warranty Disclaimers are considered to be included by reference in
     this License, but only as regards disclaiming warranties: any other
     implication that these Warranty Disclaimers may have is void and
     has no effect on the meaning of this License.

  2. VERBATIM COPYING

     You may copy and distribute the Document in any medium, either
     commercially or noncommercially, provided that this License, the
     copyright notices, and the license notice saying this License
     applies to the Document are reproduced in all copies, and that you
     add no other conditions whatsoever to those of this License.  You
     may not use technical measures to obstruct or control the reading
     or further copying of the copies you make or distribute.  However,
     you may accept compensation in exchange for copies.  If you
     distribute a large enough number of copies you must also follow the
     conditions in section 3.

     You may also lend copies, under the same conditions stated above,
     and you may publicly display copies.

  3. COPYING IN QUANTITY

     If you publish printed copies (or copies in media that commonly
     have printed covers) of the Document, numbering more than 100, and
     the Document's license notice requires Cover Texts, you must
     enclose the copies in covers that carry, clearly and legibly, all
     these Cover Texts: Front-Cover Texts on the front cover, and
     Back-Cover Texts on the back cover.  Both covers must also clearly
     and legibly identify you as the publisher of these copies.  The
     front cover must present the full title with all words of the title
     equally prominent and visible.  You may add other material on the
     covers in addition.  Copying with changes limited to the covers, as
     long as they preserve the title of the Document and satisfy these
     conditions, can be treated as verbatim copying in other respects.

     If the required texts for either cover are too voluminous to fit
     legibly, you should put the first ones listed (as many as fit
     reasonably) on the actual cover, and continue the rest onto
     adjacent pages.

     If you publish or distribute Opaque copies of the Document
     numbering more than 100, you must either include a machine-readable
     Transparent copy along with each Opaque copy, or state in or with
     each Opaque copy a computer-network location from which the general
     network-using public has access to download using public-standard
     network protocols a complete Transparent copy of the Document, free
     of added material.  If you use the latter option, you must take
     reasonably prudent steps, when you begin distribution of Opaque
     copies in quantity, to ensure that this Transparent copy will
     remain thus accessible at the stated location until at least one
     year after the last time you distribute an Opaque copy (directly or
     through your agents or retailers) of that edition to the public.

     It is requested, but not required, that you contact the authors of
     the Document well before redistributing any large number of copies,
     to give them a chance to provide you with an updated version of the
     Document.

  4. MODIFICATIONS

     You may copy and distribute a Modified Version of the Document
     under the conditions of sections 2 and 3 above, provided that you
     release the Modified Version under precisely this License, with the
     Modified Version filling the role of the Document, thus licensing
     distribution and modification of the Modified Version to whoever
     possesses a copy of it.  In addition, you must do these things in
     the Modified Version:

       A. Use in the Title Page (and on the covers, if any) a title
          distinct from that of the Document, and from those of previous
          versions (which should, if there were any, be listed in the
          History section of the Document).  You may use the same title
          as a previous version if the original publisher of that
          version gives permission.

       B. List on the Title Page, as authors, one or more persons or
          entities responsible for authorship of the modifications in
          the Modified Version, together with at least five of the
          principal authors of the Document (all of its principal
          authors, if it has fewer than five), unless they release you
          from this requirement.

       C. State on the Title page the name of the publisher of the
          Modified Version, as the publisher.

       D. Preserve all the copyright notices of the Document.

       E. Add an appropriate copyright notice for your modifications
          adjacent to the other copyright notices.

       F. Include, immediately after the copyright notices, a license
          notice giving the public permission to use the Modified
          Version under the terms of this License, in the form shown in
          the Addendum below.

       G. Preserve in that license notice the full lists of Invariant
          Sections and required Cover Texts given in the Document's
          license notice.

       H. Include an unaltered copy of this License.

       I. Preserve the section Entitled "History", Preserve its Title,
          and add to it an item stating at least the title, year, new
          authors, and publisher of the Modified Version as given on the
          Title Page.  If there is no section Entitled "History" in the
          Document, create one stating the title, year, authors, and
          publisher of the Document as given on its Title Page, then add
          an item describing the Modified Version as stated in the
          previous sentence.

       J. Preserve the network location, if any, given in the Document
          for public access to a Transparent copy of the Document, and
          likewise the network locations given in the Document for
          previous versions it was based on.  These may be placed in the
          "History" section.  You may omit a network location for a work
          that was published at least four years before the Document
          itself, or if the original publisher of the version it refers
          to gives permission.

       K. For any section Entitled "Acknowledgements" or "Dedications",
          Preserve the Title of the section, and preserve in the section
          all the substance and tone of each of the contributor
          acknowledgements and/or dedications given therein.

       L. Preserve all the Invariant Sections of the Document, unaltered
          in their text and in their titles.  Section numbers or the
          equivalent are not considered part of the section titles.

       M. Delete any section Entitled "Endorsements".  Such a section
          may not be included in the Modified Version.

       N. Do not retitle any existing section to be Entitled
          "Endorsements" or to conflict in title with any Invariant
          Section.

       O. Preserve any Warranty Disclaimers.

     If the Modified Version includes new front-matter sections or
     appendices that qualify as Secondary Sections and contain no
     material copied from the Document, you may at your option designate
     some or all of these sections as invariant.  To do this, add their
     titles to the list of Invariant Sections in the Modified Version's
     license notice.  These titles must be distinct from any other
     section titles.

     You may add a section Entitled "Endorsements", provided it contains
     nothing but endorsements of your Modified Version by various
     parties--for example, statements of peer review or that the text
     has been approved by an organization as the authoritative
     definition of a standard.

     You may add a passage of up to five words as a Front-Cover Text,
     and a passage of up to 25 words as a Back-Cover Text, to the end of
     the list of Cover Texts in the Modified Version.  Only one passage
     of Front-Cover Text and one of Back-Cover Text may be added by (or
     through arrangements made by) any one entity.  If the Document
     already includes a cover text for the same cover, previously added
     by you or by arrangement made by the same entity you are acting on
     behalf of, you may not add another; but you may replace the old
     one, on explicit permission from the previous publisher that added
     the old one.

     The author(s) and publisher(s) of the Document do not by this
     License give permission to use their names for publicity for or to
     assert or imply endorsement of any Modified Version.

  5. COMBINING DOCUMENTS

     You may combine the Document with other documents released under
     this License, under the terms defined in section 4 above for
     modified versions, provided that you include in the combination all
     of the Invariant Sections of all of the original documents,
     unmodified, and list them all as Invariant Sections of your
     combined work in its license notice, and that you preserve all
     their Warranty Disclaimers.

     The combined work need only contain one copy of this License, and
     multiple identical Invariant Sections may be replaced with a single
     copy.  If there are multiple Invariant Sections with the same name
     but different contents, make the title of each such section unique
     by adding at the end of it, in parentheses, the name of the
     original author or publisher of that section if known, or else a
     unique number.  Make the same adjustment to the section titles in
     the list of Invariant Sections in the license notice of the
     combined work.

     In the combination, you must combine any sections Entitled
     "History" in the various original documents, forming one section
     Entitled "History"; likewise combine any sections Entitled
     "Acknowledgements", and any sections Entitled "Dedications".  You
     must delete all sections Entitled "Endorsements."

  6. COLLECTIONS OF DOCUMENTS

     You may make a collection consisting of the Document and other
     documents released under this License, and replace the individual
     copies of this License in the various documents with a single copy
     that is included in the collection, provided that you follow the
     rules of this License for verbatim copying of each of the documents
     in all other respects.

     You may extract a single document from such a collection, and
     distribute it individually under this License, provided you insert
     a copy of this License into the extracted document, and follow this
     License in all other respects regarding verbatim copying of that
     document.

  7. AGGREGATION WITH INDEPENDENT WORKS

     A compilation of the Document or its derivatives with other
     separate and independent documents or works, in or on a volume of a
     storage or distribution medium, is called an "aggregate" if the
     copyright resulting from the compilation is not used to limit the
     legal rights of the compilation's users beyond what the individual
     works permit.  When the Document is included in an aggregate, this
     License does not apply to the other works in the aggregate which
     are not themselves derivative works of the Document.

     If the Cover Text requirement of section 3 is applicable to these
     copies of the Document, then if the Document is less than one half
     of the entire aggregate, the Document's Cover Texts may be placed
     on covers that bracket the Document within the aggregate, or the
     electronic equivalent of covers if the Document is in electronic
     form.  Otherwise they must appear on printed covers that bracket
     the whole aggregate.

  8. TRANSLATION

     Translation is considered a kind of modification, so you may
     distribute translations of the Document under the terms of section
     4.  Replacing Invariant Sections with translations requires special
     permission from their copyright holders, but you may include
     translations of some or all Invariant Sections in addition to the
     original versions of these Invariant Sections.  You may include a
     translation of this License, and all the license notices in the
     Document, and any Warranty Disclaimers, provided that you also
     include the original English version of this License and the
     original versions of those notices and disclaimers.  In case of a
     disagreement between the translation and the original version of
     this License or a notice or disclaimer, the original version will
     prevail.

     If a section in the Document is Entitled "Acknowledgements",
     "Dedications", or "History", the requirement (section 4) to
     Preserve its Title (section 1) will typically require changing the
     actual title.

  9. TERMINATION

     You may not copy, modify, sublicense, or distribute the Document
     except as expressly provided for under this License.  Any other
     attempt to copy, modify, sublicense or distribute the Document is
     void, and will automatically terminate your rights under this
     License.  However, parties who have received copies, or rights,
     from you under this License will not have their licenses terminated
     so long as such parties remain in full compliance.

  10. FUTURE REVISIONS OF THIS LICENSE

     The Free Software Foundation may publish new, revised versions of
     the GNU Free Documentation License from time to time.  Such new
     versions will be similar in spirit to the present version, but may
     differ in detail to address new problems or concerns.  See
     <http://www.gnu.org/copyleft/>.

     Each version of the License is given a distinguishing version
     number.  If the Document specifies that a particular numbered
     version of this License "or any later version" applies to it, you
     have the option of following the terms and conditions either of
     that specified version or of any later version that has been
     published (not as a draft) by the Free Software Foundation.  If the
     Document does not specify a version number of this License, you may
     choose any version ever published (not as a draft) by the Free
     Software Foundation.

D.1.1 ADDENDUM: How to use this License for your documents
----------------------------------------------------------

To use this License in a document you have written, include a copy of
the License in the document and put the following copyright and license
notices just after the title page:

       Copyright (C)  YEAR  YOUR NAME.
       Permission is granted to copy, distribute and/or modify this document
       under the terms of the GNU Free Documentation License, Version 1.2
       or any later version published by the Free Software Foundation;
       with no Invariant Sections, no Front-Cover Texts, and no Back-Cover
       Texts.  A copy of the license is included in the section entitled ``GNU
       Free Documentation License''.

   If you have Invariant Sections, Front-Cover Texts and Back-Cover
Texts, replace the "with...Texts."  line with this:

         with the Invariant Sections being LIST THEIR TITLES, with
         the Front-Cover Texts being LIST, and with the Back-Cover Texts
         being LIST.

   If you have Invariant Sections without Cover Texts, or some other
combination of the three, merge those two alternatives to suit the
situation.

   If your document contains nontrivial examples of program code, we
recommend releasing these examples in parallel under your choice of free
software license, such as the GNU General Public License, to permit
their use in free software.